/************************************************************************/
/* Copyright (C) 2005 by Peter Swoboda                                  */
/* peter.swoboda@paranoya.ch                                            */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License, or    */
/* any later version.                                                   */
/*                                                                      */
/* This program is distributed in the hope that it will be useful,      */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        */
/* GNU General Public License for more details.                         */
/*                                                                      */
/* You should have received a copy of the GNU General Public License    */
/* along with this program; if not, write to the                        */
/* Free Software Foundation, Inc.,                                      */
/* 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            */
/*                                                                      */
/************************************************************************/

#include <qapplication.h>
#include <qpixmap.h>
#include <qsplashscreen.h>
#include <qprocess.h>
#include <qmessagebox.h>
#include <qstringlist.h> 
#include <qstring.h>
#include <qmessagebox.h>
#include <iostream>
#include "mainform.h"

using namespace std;

bool which(char *arg)
{
    QProcess *proc = new QProcess();
    proc->addArgument("which");
    proc->addArgument(arg);
    proc->start();
    while(proc->isRunning())
    {
	sleep(1);
    }
    if(proc->exitStatus()!=0)
	return false;
    else
	return  true;
}

int initCard()
{
    QProcess *proc = new QProcess();
    int i = 0;
    proc->addArgument("duneinit");
    proc->start();
    while(proc->isRunning())
    {
	sleep(1);
	i++;
	if(i>=30)
	    proc->kill();
    }
    if(proc->normalExit())
	return proc->exitStatus();
    else
	return 1;
}

char *get_mplayer_modes (const char *string) {
    char *result;
    uint i;
    int j = 0;
    bool ok = false;
    result = (char *) malloc (strlen (string)); 
    memset (result, 0, strlen (string));
    for (i = 0; i < strlen (string); i++) 
    {
	if (string[i] == '\t') 
	{
	    if (ok) 
	    { 
		ok = false; 
		result[j++] = ' '; 
	    }
	    else ok = true;
	    continue;  
	}
	if (ok) 
	    result[j++] = string[i];
    }
    result[j] = '\0'; 
    return result;
}

char *readAO()
{
    QProcess *proc = new QProcess();
    proc->addArgument("mplayer");
    proc->addArgument("-ao");
    proc->addArgument("help");
    proc->start();
    while(proc->isRunning()){
	sleep(1);
    }
    return get_mplayer_modes(proc->readStdout());
}

char *readVO()
{
    QProcess *proc = new QProcess();
    proc->addArgument("mplayer");
    proc->addArgument("-vo");
    proc->addArgument("help");
    proc->start();
    while(proc->isRunning())
    {
	sleep(1);
    }
    return get_mplayer_modes(proc->readStdout());
}


int main( int argc, char ** argv )
{
    QApplication a( argc, argv );
    QPixmap pixmap(a.applicationDirPath()+"/splash.png");
    QSplashScreen *splash = new QSplashScreen( pixmap );
    splash->show();
    splash->message("Dedecting applications..", Qt::AlignBottom);
    if(!which("duneinit"))
    {
	QMessageBox::critical( 0, "PCTV Deluxe", "Please install dunetools first!");
	return 1;
    }
    if(!which("dunerec"))
    {
	QMessageBox::critical( 0, "PCTV Deluxe", "Please install dunetools first!");
	return 1;
    }
    if(!which("mplayer"))
    {
	QMessageBox::critical( 0, "PCTV Deluxe", "Please install mplayer first!");
	return 1;
    }
    MainForm *w = new MainForm();
    splash->message("Init Card..", Qt::AlignBottom);
    if(initCard()==0)
	splash->message("Init Card..OK", Qt::AlignBottom);
    else
    {
	splash->message("Init Card..Failed", Qt::AlignBottom);
	QMessageBox::critical( 0, "PCTV Deluxe", "Card initialisation failed!");
	sleep(2);
	return 1;
    }
    splash->message("Reading audio options...", Qt::AlignBottom);
    w->addAO(readAO());
    splash->message("Reading video options...", Qt::AlignBottom);
    w->addVO(readVO());
    w->show();
    a.connect( &a, SIGNAL( lastWindowClosed() ), &a, SLOT( quit() ) );
    splash->finish( w );
    delete splash;
    return a.exec();
}
